#include "stdafx.h"
#include "registe.h" 
/////////////////////////////////////////////////////////////////////////////
// CMyRegKey
///////////////////////////////////////////////////////////////////////////// 

CMyRegKey:: CMyRegKey()
{
	m_hKey = NULL;
} 

CMyRegKey:: ~CMyRegKey()
{
	RegClose();
} 
// עĺRegOpen ָҪע HKEY, Լע 
// Ϣȫ··ڣ贴һ· RegCreateKeyEx API
// ص HKEY Ϊ m_hKey 洢 

long CMyRegKey::RegOpen(HKEY hKeyRoot,LPCTSTR pszPath) 
{ 
	DWORD dw;
	m_sPath = pszPath; 
	return RegCreateKeyEx(hKeyRoot,pszPath,0L,NULL,REG_OPTION_VOLATILE,KEY_ALL_ACCESS,NULL,&m_hKey,&dw);
} 

void CMyRegKey::RegClose()
{
	if(m_hKey)
	{
		RegCloseKey (m_hKey);
		m_hKey = NULL; 
	}
} 

long CMyRegKey::RegWrite(LPCTSTR pszKey,DWORD dwVal)
{ 
	ASSERT(m_hKey); 
	ASSERT(pszKey);
//	ASSERT(pData&&dwLength>0);
//	ASSERT(AfxIsValidAddress(pData,dwLength,FALSE)); 
	return RegSetValueEx(m_hKey,pszKey,0L,REG_DWORD,(CONST BYTE *)&dwVal,sizeof(DWORD));
} 

long CMyRegKey::RegWrite(LPCTSTR pszKey,LPCTSTR pszData)
{ 
	ASSERT(m_hKey);
	ASSERT(pszKey);
	ASSERT(pszData); 
//	ASSERT(pData&&dwLength>0);
	ASSERT(AfxIsValidAddress(pszData,strlen(pszData),FALSE)); 
	return RegSetValueEx(m_hKey,pszKey,0L,REG_SZ,(CONST BYTE *)pszData,strlen (pszData)+1); 
} 

long CMyRegKey::RegWrite(LPCTSTR pszKey,const BYTE *pData,DWORD dwLength)
{ 
	ASSERT(m_hKey);
	ASSERT(pszKey);
	ASSERT(AfxIsValidAddress (pData,dwLength,FALSE)); 
	ASSERT(pData&&dwLength>0);
	ASSERT(AfxIsValidAddress(pData,dwLength,FALSE)); 
	return RegSetValueEx(m_hKey,pszKey,0L,REG_BINARY,pData,dwLength); 
}

long CMyRegKey::RegRead (LPCTSTR pszKey,DWORD& dwVal)
{ 
	ASSERT(m_hKey);
	ASSERT(pszKey); 
	DWORD dwType;
	DWORD dwSize = sizeof (DWORD);
	DWORD dwDest; 
	long LRet = RegQueryValueEx(m_hKey,(LPSTR)pszKey,NULL,&dwType,(BYTE *)&dwDest,&dwSize); 
	if(LRet==ERROR_SUCCESS)
		dwVal = dwDest;
	return LRet; 
} 

long CMyRegKey::RegRead (LPCTSTR pszKey,CString& sVal)
{ 
	ASSERT(m_hKey);
	ASSERT(pszKey); 
	DWORD dwType;
	DWORD dwSize = 200;
	char string[200]; 
	long IReturn = RegQueryValueEx(m_hKey,(LPSTR)pszKey,NULL,&dwType,(BYTE *)string,&dwSize); 
	if(IReturn==ERROR_SUCCESS) 
		sVal = string;
	return IReturn; 
} 

long CMyRegKey::RegRead (LPCTSTR pszKey,BYTE * pData,DWORD& dwLen)
{ 
	ASSERT(m_hKey);
	ASSERT(pszKey); 
	DWORD dwType;
	return RegQueryValueEx(m_hKey,(LPSTR)pszKey,NULL,&dwType,pData,&dwLen); 
} 

long CMyRegKey::RegDelKey(LPCTSTR pszKey)
{
	return RegDeleteKey(m_hKey,(LPSTR)pszKey);
}

long CMyRegKey::RegDelValue(LPCTSTR pszKey)
{
	return RegDeleteValue(m_hKey,(LPSTR)pszKey);
}
